/[gentoo-x86]/eclass/python.eclass
Gentoo

Contents of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.95 - (hide annotations) (download)
Sat Mar 20 17:59:40 2010 UTC (5 years, 2 months ago) by arfrever
Branch: MAIN
Changes since 1.94: +147 -79 lines
Fix handling of PYTHON_USE_WITH_OPT in python_pkg_setup().
Improve error messages in some functions.
Delete python_set_build_dir_symlink().
Fix wrapper scripts generated by python_generate_wrapper_scripts().
Improve deprecation warnings in python_version(), python_mod_exists() and python_tkinter_exists().

1 arfrever 1.83 # Copyright 1999-2010 Gentoo Foundation
2 liquidx 1.1 # Distributed under the terms of the GNU General Public License v2
3 arfrever 1.95 # $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.94 2010/03/13 13:46:20 arfrever Exp $
4 liquidx 1.1
5 dev-zero 1.33 # @ECLASS: python.eclass
6     # @MAINTAINER:
7 arfrever 1.88 # Gentoo Python Project <python@gentoo.org>
8     # @BLURB: Eclass for Python packages
9 dev-zero 1.33 # @DESCRIPTION:
10 arfrever 1.88 # The python eclass contains miscellaneous, useful functions for Python packages.
11 liquidx 1.1
12 arfrever 1.65 inherit multilib
13 liquidx 1.2
14 arfrever 1.87 if ! has "${EAPI:-0}" 0 1 2 3; then
15 arfrever 1.83 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16     fi
17    
18 arfrever 1.88 _CPYTHON2_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19     _CPYTHON3_SUPPORTED_ABIS=(3.0 3.1 3.2)
20     _JYTHON_SUPPORTED_ABIS=(2.5-jython)
21 arfrever 1.87
22     # @ECLASS-VARIABLE: PYTHON_DEPEND
23     # @DESCRIPTION:
24     # Specification of dependency on dev-lang/python.
25     # Syntax:
26     # PYTHON_DEPEND: [[!]USE_flag? ]<version_components_group>[ version_components_group]
27     # version_components_group: <major_version[:[minimal_version][:maximal_version]]>
28     # major_version: <2|3|*>
29     # minimal_version: <minimal_major_version.minimal_minor_version>
30     # maximal_version: <maximal_major_version.maximal_minor_version>
31    
32     _parse_PYTHON_DEPEND() {
33 arfrever 1.88 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
34 arfrever 1.87
35     version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
36     version_components_groups="${PYTHON_DEPEND}"
37    
38     if [[ "${version_components_groups}" =~ ^((\!)?[[:alnum:]_-]+\?\ )?${version_components_group_regex}(\ ${version_components_group_regex})?$ ]]; then
39     if [[ "${version_components_groups}" =~ ^(\!)?[[:alnum:]_-]+\? ]]; then
40     USE_flag="${version_components_groups%\? *}"
41     version_components_groups="${version_components_groups#* }"
42     fi
43     if [[ "${version_components_groups}" =~ ("*".*" "|" *"|^2.*\ (2|\*)|^3.*\ (3|\*)) ]]; then
44     die "Invalid syntax of PYTHON_DEPEND: Incorrectly specified groups of versions"
45     fi
46    
47     version_components_groups="${version_components_groups// /$'\n'}"
48     while read version_components_group; do
49     major_version="${version_components_group:0:1}"
50     minimal_version="${version_components_group:2}"
51     minimal_version="${minimal_version%:*}"
52     maximal_version="${version_components_group:$((3 + ${#minimal_version}))}"
53    
54     if [[ "${major_version}" =~ ^(2|3)$ ]]; then
55     if [[ -n "${minimal_version}" && "${major_version}" != "${minimal_version:0:1}" ]]; then
56     die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' not in specified group of versions"
57     fi
58     if [[ -n "${maximal_version}" && "${major_version}" != "${maximal_version:0:1}" ]]; then
59     die "Invalid syntax of PYTHON_DEPEND: Maximal version '${maximal_version}' not in specified group of versions"
60     fi
61     fi
62    
63     if [[ "${major_version}" == "2" ]]; then
64     python2="1"
65 arfrever 1.88 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}")
66 arfrever 1.87 python2_minimal_version="${minimal_version}"
67     python2_maximal_version="${maximal_version}"
68     elif [[ "${major_version}" == "3" ]]; then
69     python3="1"
70 arfrever 1.88 python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}")
71 arfrever 1.87 python3_minimal_version="${minimal_version}"
72     python3_maximal_version="${maximal_version}"
73     else
74     python_all="1"
75 arfrever 1.88 python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}")
76 arfrever 1.87 python_minimal_version="${minimal_version}"
77     python_maximal_version="${maximal_version}"
78     fi
79    
80     if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
81     die "Invalid syntax of PYTHON_DEPEND: Unrecognized minimal version '${minimal_version}'"
82     fi
83     if [[ -n "${maximal_version}" ]] && ! has "${maximal_version}" "${python_versions[@]}"; then
84     die "Invalid syntax of PYTHON_DEPEND: Unrecognized maximal version '${maximal_version}'"
85     fi
86    
87     if [[ -n "${minimal_version}" && -n "${maximal_version}" && "${minimal_version}" > "${maximal_version}" ]]; then
88     die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' greater than maximal version '${maximal_version}'"
89     fi
90     done <<< "${version_components_groups}"
91    
92 arfrever 1.88 _PYTHON_ATOMS=()
93    
94     _append_accepted_versions_range() {
95 arfrever 1.87 local accepted_version="0" i
96     for ((i = "${#python_versions[@]}"; i >= 0; i--)); do
97     if [[ "${python_versions[${i}]}" == "${python_maximal_version}" ]]; then
98     accepted_version="1"
99     fi
100     if [[ "${accepted_version}" == "1" ]]; then
101 arfrever 1.88 _PYTHON_ATOMS+=("=dev-lang/python-${python_versions[${i}]}*")
102 arfrever 1.87 fi
103     if [[ "${python_versions[${i}]}" == "${python_minimal_version}" ]]; then
104     accepted_version="0"
105     fi
106     done
107     }
108    
109     if [[ "${python_all}" == "1" ]]; then
110 arfrever 1.88 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
111     _PYTHON_ATOMS+=("dev-lang/python")
112     else
113     python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}")
114     python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
115     python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
116     _append_accepted_versions_range
117     fi
118 arfrever 1.87 else
119     if [[ "${python3}" == "1" ]]; then
120 arfrever 1.88 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
121     _PYTHON_ATOMS+=("=dev-lang/python-3*")
122     else
123     python_versions=("${_CPYTHON3_SUPPORTED_ABIS[@]}")
124     python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
125     python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
126     _append_accepted_versions_range
127     fi
128 arfrever 1.87 fi
129     if [[ "${python2}" == "1" ]]; then
130 arfrever 1.88 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
131     _PYTHON_ATOMS+=("=dev-lang/python-2*")
132     else
133     python_versions=("${_CPYTHON2_SUPPORTED_ABIS[@]}")
134     python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
135     python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
136     _append_accepted_versions_range
137     fi
138 arfrever 1.87 fi
139     fi
140    
141 arfrever 1.88 unset -f _append_accepted_versions_range
142 arfrever 1.87
143 arfrever 1.88 if [[ "${#_PYTHON_ATOMS[@]}" -gt 1 ]]; then
144     DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
145     RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
146     else
147     DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
148     RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
149     fi
150 arfrever 1.87 else
151     die "Invalid syntax of PYTHON_DEPEND"
152     fi
153     }
154    
155 arfrever 1.89 DEPEND=">=app-admin/eselect-python-20091230"
156 arfrever 1.87 RDEPEND="${DEPEND}"
157    
158     if [[ -n "${PYTHON_DEPEND}" && -n "${NEED_PYTHON}" ]]; then
159     die "PYTHON_DEPEND and NEED_PYTHON cannot be set simultaneously"
160     elif [[ -n "${PYTHON_DEPEND}" ]]; then
161     _parse_PYTHON_DEPEND
162     elif [[ -n "${NEED_PYTHON}" ]]; then
163     if ! has "${EAPI:-0}" 0 1 2; then
164     eerror "Use PYTHON_DEPEND instead of NEED_PYTHON."
165     die "NEED_PYTHON cannot be used in this EAPI"
166     fi
167 arfrever 1.88 _PYTHON_ATOMS=(">=dev-lang/python-${NEED_PYTHON}")
168     DEPEND+="${DEPEND:+ }${_PYTHON_ATOMS[@]}"
169     RDEPEND+="${RDEPEND:+ }${_PYTHON_ATOMS[@]}"
170 betelgeuse 1.55 else
171 arfrever 1.88 _PYTHON_ATOMS=("dev-lang/python")
172 carlo 1.22 fi
173 liquidx 1.18
174 arfrever 1.85 # @ECLASS-VARIABLE: PYTHON_USE_WITH
175     # @DESCRIPTION:
176 arfrever 1.87 # Set this to a space separated list of USE flags the Python slot in use must be built with.
177 liquidx 1.18
178 arfrever 1.85 # @ECLASS-VARIABLE: PYTHON_USE_WITH_OR
179 dev-zero 1.33 # @DESCRIPTION:
180 arfrever 1.87 # Set this to a space separated list of USE flags of which one must be turned on for the slot in use.
181 liquidx 1.18
182 arfrever 1.85 # @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT
183     # @DESCRIPTION:
184 arfrever 1.87 # Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or
185     # PYTHON_USE_WITH_OR atoms conditional under a USE flag.
186 liquidx 1.1
187 arfrever 1.85 # @FUNCTION: python_pkg_setup
188 arfrever 1.56 # @DESCRIPTION:
189 arfrever 1.85 # Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags
190     # are respected. Only exported if one of those variables is set.
191     if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
192     python_pkg_setup() {
193 arfrever 1.92 # Check if phase is pkg_setup().
194     [[ "${EBUILD_PHASE}" != "setup" ]] && die "${FUNCNAME}() can be used only in pkg_setup() phase"
195    
196 arfrever 1.85 python_pkg_setup_fail() {
197     eerror "${1}"
198     die "${1}"
199     }
200    
201 arfrever 1.95 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
202     if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
203     use ${PYTHON_USE_WITH_OPT#!} && return
204     else
205     use !${PYTHON_USE_WITH_OPT} && return
206     fi
207     fi
208 arfrever 1.56
209 arfrever 1.85 python_pkg_setup_check_USE_flags() {
210     local pyatom use
211 arfrever 1.88 pyatom="$(python_get_implementational_package)"
212 arfrever 1.56
213 arfrever 1.85 for use in ${PYTHON_USE_WITH}; do
214     if ! has_version "${pyatom}[${use}]"; then
215     python_pkg_setup_fail "Please rebuild ${pyatom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
216     fi
217     done
218 arfrever 1.82
219 arfrever 1.85 for use in ${PYTHON_USE_WITH_OR}; do
220     if has_version "${pyatom}[${use}]"; then
221     return
222     fi
223     done
224 arfrever 1.82
225 arfrever 1.85 if [[ ${PYTHON_USE_WITH_OR} ]]; then
226     python_pkg_setup_fail "Please rebuild ${pyatom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
227 arfrever 1.83 fi
228 arfrever 1.85 }
229    
230 arfrever 1.95 if _python_package_supporting_installation_for_multiple_python_abis; then
231 arfrever 1.85 python_execute_function -q python_pkg_setup_check_USE_flags
232 arfrever 1.56 else
233 arfrever 1.85 python_pkg_setup_check_USE_flags
234 arfrever 1.56 fi
235 arfrever 1.88
236     unset -f python_pkg_setup_check_USE_flags python_pkg_setup_fail
237 arfrever 1.85 }
238    
239     EXPORT_FUNCTIONS pkg_setup
240 arfrever 1.56
241 arfrever 1.92 _PYTHON_USE_WITH_ATOMS_ARRAY=()
242 arfrever 1.85 if [[ -n "${PYTHON_USE_WITH}" ]]; then
243 arfrever 1.88 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
244 arfrever 1.92 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]")
245 arfrever 1.88 done
246 arfrever 1.85 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
247 arfrever 1.87 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
248 arfrever 1.88 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
249 arfrever 1.92 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]")
250 arfrever 1.88 done
251 arfrever 1.85 done
252 arfrever 1.87 unset _USE_flag
253 arfrever 1.92 fi
254     if [[ "${#_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" -gt 1 ]]; then
255     _PYTHON_USE_WITH_ATOMS="|| ( ${_PYTHON_USE_WITH_ATOMS_ARRAY[@]} )"
256     else
257     _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
258 arfrever 1.56 fi
259 arfrever 1.85 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
260 arfrever 1.92 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
261 arfrever 1.78 fi
262 arfrever 1.92 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
263     RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
264     unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
265 arfrever 1.85 fi
266 arfrever 1.56
267 arfrever 1.87 unset _PYTHON_ATOMS
268    
269 arfrever 1.85 # ================================================================================================
270 arfrever 1.95 # =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============
271 arfrever 1.85 # ================================================================================================
272 arfrever 1.84
273 arfrever 1.86 # @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
274     # @DESCRIPTION:
275 arfrever 1.88 # Set this in EAPI <= 4 to indicate that current package supports installation for
276 arfrever 1.95 # multiple Python ABIs.
277 arfrever 1.86
278 arfrever 1.90 # @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
279 arfrever 1.82 # @DESCRIPTION:
280 arfrever 1.90 # Set this to export phase functions for the following ebuild phases:
281 arfrever 1.85 # src_prepare, src_configure, src_compile, src_test, src_install.
282 arfrever 1.94 if ! has "${EAPI:-0}" 0 1; then
283 arfrever 1.85 python_src_prepare() {
284 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
285     die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
286     fi
287    
288 arfrever 1.85 python_copy_sources
289     }
290 arfrever 1.82
291 arfrever 1.85 for python_default_function in src_configure src_compile src_test src_install; do
292 arfrever 1.94 eval "python_${python_default_function}() {
293 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
294     die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
295     fi
296    
297 arfrever 1.94 python_execute_function -d -s \"\$@\"
298     }"
299 arfrever 1.85 done
300     unset python_default_function
301 arfrever 1.82
302 arfrever 1.90 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
303     EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
304     fi
305 arfrever 1.85 fi
306 arfrever 1.82
307 arfrever 1.77 unset PYTHON_ABIS
308    
309 arfrever 1.56 # @FUNCTION: validate_PYTHON_ABIS
310     # @DESCRIPTION:
311 arfrever 1.76 # Ensure that PYTHON_ABIS variable has valid value.
312 arfrever 1.86 # This function usually should not be directly called in ebuilds.
313 arfrever 1.56 validate_PYTHON_ABIS() {
314 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
315     die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
316 arfrever 1.66 fi
317    
318 arfrever 1.90 _python_initial_sanity_checks
319 arfrever 1.57
320 arfrever 1.82 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 5.
321     if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
322 arfrever 1.87 local PYTHON_ABI restricted_ABI support_ABI supported_PYTHON_ABIS=
323 arfrever 1.88 PYTHON_ABI_SUPPORTED_VALUES="${_CPYTHON2_SUPPORTED_ABIS[@]} ${_CPYTHON3_SUPPORTED_ABIS[@]} ${_JYTHON_SUPPORTED_ABIS[@]}"
324 arfrever 1.68
325 arfrever 1.70 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
326 arfrever 1.94 local cpython_enabled="0"
327 arfrever 1.75
328 arfrever 1.68 if [[ -z "${USE_PYTHON}" ]]; then
329     die "USE_PYTHON variable is empty"
330 arfrever 1.56 fi
331 arfrever 1.68
332 arfrever 1.78 for PYTHON_ABI in ${USE_PYTHON}; do
333     if ! has "${PYTHON_ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then
334     die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
335 arfrever 1.68 fi
336 arfrever 1.75
337 arfrever 1.94 if has "${PYTHON_ABI}" "${_CPYTHON2_SUPPORTED_ABIS[@]}" "${_CPYTHON3_SUPPORTED_ABIS[@]}"; then
338     cpython_enabled="1"
339 arfrever 1.75 fi
340    
341 arfrever 1.68 support_ABI="1"
342 arfrever 1.66 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
343 arfrever 1.78 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
344 arfrever 1.66 support_ABI="0"
345     break
346     fi
347     done
348 arfrever 1.82 [[ "${support_ABI}" == "1" ]] && export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
349 arfrever 1.68 done
350    
351     if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
352 arfrever 1.95 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
353 arfrever 1.66 fi
354 arfrever 1.75
355 arfrever 1.94 if [[ "${cpython_enabled}" == "0" ]]; then
356 arfrever 1.95 die "USE_PYTHON variable does not enable any CPython ABI"
357 arfrever 1.88 fi
358 arfrever 1.68 else
359 arfrever 1.76 local python_version python2_version= python3_version= support_python_major_version
360    
361 arfrever 1.88 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
362 arfrever 1.74
363     if has_version "=dev-lang/python-2*"; then
364 arfrever 1.87 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
365     die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
366 arfrever 1.74 fi
367    
368 arfrever 1.88 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
369 arfrever 1.74
370 arfrever 1.88 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
371 arfrever 1.74 support_python_major_version="1"
372     for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
373 arfrever 1.78 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
374 arfrever 1.74 support_python_major_version="0"
375     fi
376     done
377     [[ "${support_python_major_version}" == "1" ]] && break
378     done
379     if [[ "${support_python_major_version}" == "1" ]]; then
380     for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
381 arfrever 1.77 if [[ "${python2_version}" == ${restricted_ABI} ]]; then
382 arfrever 1.84 die "Active version of Python 2 is not supported by ${CATEGORY}/${PF}"
383 arfrever 1.74 fi
384     done
385     else
386     python2_version=""
387     fi
388     fi
389 arfrever 1.56
390 arfrever 1.74 if has_version "=dev-lang/python-3*"; then
391 arfrever 1.87 if [[ "$(readlink "${EPREFIX}/usr/bin/python3")" != "python3."* ]]; then
392     die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
393 arfrever 1.68 fi
394 arfrever 1.74
395 arfrever 1.88 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
396 arfrever 1.74
397 arfrever 1.88 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do
398 arfrever 1.74 support_python_major_version="1"
399     for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
400 arfrever 1.78 if [[ "${PYTHON_ABI}" == ${restricted_ABI} ]]; then
401 arfrever 1.74 support_python_major_version="0"
402     fi
403     done
404     [[ "${support_python_major_version}" == "1" ]] && break
405     done
406     if [[ "${support_python_major_version}" == "1" ]]; then
407     for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do
408 arfrever 1.77 if [[ "${python3_version}" == ${restricted_ABI} ]]; then
409 arfrever 1.84 die "Active version of Python 3 is not supported by ${CATEGORY}/${PF}"
410 arfrever 1.74 fi
411     done
412     else
413     python3_version=""
414     fi
415     fi
416    
417 arfrever 1.82 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
418 arfrever 1.87 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
419 arfrever 1.82 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
420     die "Incorrect configuration of Python"
421     fi
422     if [[ -n "${python3_version}" && "${python_version}" == "3."* && "${python_version}" != "${python3_version}" ]]; then
423 arfrever 1.87 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python3' symlink"
424 arfrever 1.76 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
425     die "Incorrect configuration of Python"
426     fi
427    
428 arfrever 1.74 PYTHON_ABIS="${python2_version} ${python3_version}"
429     PYTHON_ABIS="${PYTHON_ABIS# }"
430     export PYTHON_ABIS="${PYTHON_ABIS% }"
431 arfrever 1.68 fi
432 arfrever 1.56 fi
433 arfrever 1.66
434 arfrever 1.90 _python_final_sanity_checks
435 arfrever 1.56 }
436    
437     # @FUNCTION: python_execute_function
438 arfrever 1.90 # @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
439 arfrever 1.56 # @DESCRIPTION:
440 arfrever 1.60 # Execute specified function for each value of PYTHON_ABIS, optionally passing additional
441     # arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
442 arfrever 1.56 python_execute_function() {
443 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
444     die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
445     fi
446    
447 arfrever 1.90 _python_set_color_variables
448    
449     local action action_message action_message_template= default_function="0" failure_message failure_message_template= final_ABI="0" function i iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" separate_build_dirs="0" source_dir=
450 arfrever 1.56
451     while (($#)); do
452     case "$1" in
453     --action-message)
454     action_message_template="$2"
455     shift
456     ;;
457 arfrever 1.58 -d|--default-function)
458     default_function="1"
459     ;;
460 arfrever 1.56 --failure-message)
461     failure_message_template="$2"
462     shift
463     ;;
464 arfrever 1.90 -f|--final-ABI)
465     final_ABI="1"
466     ;;
467 arfrever 1.56 --nonfatal)
468     nonfatal="1"
469     ;;
470     -q|--quiet)
471     quiet="1"
472     ;;
473     -s|--separate-build-dirs)
474     separate_build_dirs="1"
475     ;;
476 arfrever 1.81 --source-dir)
477     source_dir="$2"
478     shift
479     ;;
480 arfrever 1.71 --)
481 arfrever 1.87 shift
482 arfrever 1.71 break
483     ;;
484 arfrever 1.56 -*)
485 arfrever 1.67 die "${FUNCNAME}(): Unrecognized option '$1'"
486 arfrever 1.56 ;;
487     *)
488     break
489     ;;
490     esac
491     shift
492     done
493    
494 arfrever 1.81 if [[ -n "${source_dir}" && "${separate_build_dirs}" == 0 ]]; then
495     die "${FUNCNAME}(): '--source-dir' option can be specified only with '--separate-build-dirs' option"
496     fi
497    
498 arfrever 1.58 if [[ "${default_function}" == "0" ]]; then
499 arfrever 1.83 if [[ "$#" -eq 0 ]]; then
500 arfrever 1.58 die "${FUNCNAME}(): Missing function name"
501     fi
502     function="$1"
503     shift
504 arfrever 1.67
505     if [[ -z "$(type -t "${function}")" ]]; then
506 arfrever 1.84 die "${FUNCNAME}(): '${function}' function is not defined"
507 arfrever 1.67 fi
508 arfrever 1.58 else
509     if has "${EAPI:-0}" 0 1; then
510 arfrever 1.67 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI"
511 arfrever 1.58 fi
512    
513     if [[ "${EBUILD_PHASE}" == "configure" ]]; then
514 arfrever 1.82 if has "${EAPI}" 2 3; then
515 arfrever 1.61 python_default_function() {
516 arfrever 1.94 econf "$@"
517 arfrever 1.61 }
518     else
519     python_default_function() {
520 arfrever 1.94 nonfatal econf "$@"
521 arfrever 1.61 }
522     fi
523 arfrever 1.58 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then
524     python_default_function() {
525 arfrever 1.94 emake "$@"
526 arfrever 1.58 }
527     elif [[ "${EBUILD_PHASE}" == "test" ]]; then
528     python_default_function() {
529     if emake -j1 -n check &> /dev/null; then
530 arfrever 1.94 emake -j1 check "$@"
531 arfrever 1.58 elif emake -j1 -n test &> /dev/null; then
532 arfrever 1.94 emake -j1 test "$@"
533 arfrever 1.58 fi
534     }
535     elif [[ "${EBUILD_PHASE}" == "install" ]]; then
536     python_default_function() {
537 arfrever 1.94 emake DESTDIR="${D}" install "$@"
538 arfrever 1.58 }
539     else
540 arfrever 1.82 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase"
541 arfrever 1.58 fi
542     function="python_default_function"
543 arfrever 1.56 fi
544    
545 arfrever 1.95 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
546 arfrever 1.87 for ((i = 1; i < "${#FUNCNAME[@]}"; i++)); do
547 arfrever 1.88 if [[ "${FUNCNAME[${i}]}" == "${FUNCNAME}" ]]; then
548 arfrever 1.87 die "${FUNCNAME}(): Invalid call stack"
549     fi
550     done
551    
552 arfrever 1.56 if [[ "${quiet}" == "0" ]]; then
553     [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
554     [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
555     [[ "${EBUILD_PHASE}" == "prepare" ]] && action="Preparation"
556     [[ "${EBUILD_PHASE}" == "configure" ]] && action="Configuration"
557     [[ "${EBUILD_PHASE}" == "compile" ]] && action="Building"
558     [[ "${EBUILD_PHASE}" == "test" ]] && action="Testing"
559     [[ "${EBUILD_PHASE}" == "install" ]] && action="Installation"
560     [[ "${EBUILD_PHASE}" == "preinst" ]] && action="Preinstallation"
561     [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation"
562     [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation"
563     [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation"
564     fi
565    
566 arfrever 1.90 validate_PYTHON_ABIS
567     if [[ "${final_ABI}" == "1" ]]; then
568     iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
569 arfrever 1.56 else
570 arfrever 1.90 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
571 arfrever 1.56 fi
572 arfrever 1.90 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
573 arfrever 1.56 if [[ "${quiet}" == "0" ]]; then
574     if [[ -n "${action_message_template}" ]]; then
575     action_message="$(eval echo -n "${action_message_template}")"
576     else
577 arfrever 1.88 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..."
578 arfrever 1.56 fi
579 arfrever 1.90 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
580 arfrever 1.56 fi
581 arfrever 1.66
582 arfrever 1.56 if [[ "${separate_build_dirs}" == "1" ]]; then
583 arfrever 1.81 if [[ -n "${source_dir}" ]]; then
584     export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}"
585     else
586     export BUILDDIR="${S}-${PYTHON_ABI}"
587     fi
588 arfrever 1.60 pushd "${BUILDDIR}" > /dev/null || die "pushd failed"
589     else
590     export BUILDDIR="${S}"
591 arfrever 1.56 fi
592 arfrever 1.66
593 arfrever 1.73 previous_directory="$(pwd)"
594     previous_directory_stack="$(dirs -p)"
595     previous_directory_stack_length="$(dirs -p | wc -l)"
596 arfrever 1.72
597 arfrever 1.82 if ! has "${EAPI}" 0 1 2 3 && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
598 arfrever 1.66 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
599     else
600     EPYTHON="$(PYTHON)" "${function}" "$@"
601     fi
602    
603     if [[ "$?" != "0" ]]; then
604 arfrever 1.56 if [[ -n "${failure_message_template}" ]]; then
605     failure_message="$(eval echo -n "${failure_message_template}")"
606     else
607 arfrever 1.88 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function"
608 arfrever 1.56 fi
609 arfrever 1.66
610 arfrever 1.69 if [[ "${nonfatal}" == "1" ]]; then
611     if [[ "${quiet}" == "0" ]]; then
612 arfrever 1.90 ewarn "${_RED}${failure_message}${_NORMAL}"
613 arfrever 1.69 fi
614 arfrever 1.90 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
615 arfrever 1.70 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
616 arfrever 1.78 local enabled_PYTHON_ABIS= other_PYTHON_ABI
617     for other_PYTHON_ABI in ${PYTHON_ABIS}; do
618 arfrever 1.82 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
619 arfrever 1.70 done
620 arfrever 1.82 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
621 arfrever 1.70 fi
622 arfrever 1.56 if [[ "${quiet}" == "0" ]]; then
623 arfrever 1.90 ewarn "${_RED}${failure_message}${_NORMAL}"
624 arfrever 1.56 fi
625 arfrever 1.69 if [[ -z "${PYTHON_ABIS}" ]]; then
626 arfrever 1.95 die "${function}() function failed with all enabled Python ABIs"
627 arfrever 1.69 fi
628 arfrever 1.56 else
629     die "${failure_message}"
630     fi
631     fi
632 arfrever 1.66
633 arfrever 1.84 # Ensure that directory stack has not been decreased.
634 arfrever 1.73 if [[ "$(dirs -p | wc -l)" -lt "${previous_directory_stack_length}" ]]; then
635 arfrever 1.72 die "Directory stack decreased illegally"
636     fi
637    
638 arfrever 1.73 # Avoid side effects of earlier returning from the specified function.
639     while [[ "$(dirs -p | wc -l)" -gt "${previous_directory_stack_length}" ]]; do
640 arfrever 1.72 popd > /dev/null || die "popd failed"
641     done
642    
643 arfrever 1.84 # Ensure that the bottom part of directory stack has not been changed. Restore
644 arfrever 1.73 # previous directory (from before running of the specified function) before
645     # comparison of directory stacks to avoid mismatch of directory stacks after
646     # potential using of 'cd' to change current directory. Restoration of previous
647     # directory allows to safely use 'cd' to change current directory in the
648     # specified function without changing it back to original directory.
649     cd "${previous_directory}"
650     if [[ "$(dirs -p)" != "${previous_directory_stack}" ]]; then
651     die "Directory stack changed illegally"
652     fi
653    
654 arfrever 1.56 if [[ "${separate_build_dirs}" == "1" ]]; then
655     popd > /dev/null || die "popd failed"
656     fi
657 arfrever 1.60 unset BUILDDIR
658 arfrever 1.56 done
659 arfrever 1.58
660     if [[ "${default_function}" == "1" ]]; then
661     unset -f python_default_function
662     fi
663 arfrever 1.56 }
664    
665 arfrever 1.85 # @FUNCTION: python_copy_sources
666 arfrever 1.90 # @USAGE: <directory="${S}"> [directory]
667 arfrever 1.77 # @DESCRIPTION:
668 arfrever 1.88 # Copy unpacked sources of current package to separate build directory for each Python ABI.
669 arfrever 1.85 python_copy_sources() {
670 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
671     die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
672     fi
673    
674 arfrever 1.90 local dir dirs=() PYTHON_ABI
675 arfrever 1.77
676     if [[ "$#" -eq 0 ]]; then
677 arfrever 1.85 if [[ "${WORKDIR}" == "${S}" ]]; then
678     die "${FUNCNAME}() cannot be used"
679     fi
680 arfrever 1.94 dirs=("${S%/}")
681 arfrever 1.85 else
682 arfrever 1.90 dirs=("$@")
683 arfrever 1.77 fi
684    
685 arfrever 1.85 validate_PYTHON_ABIS
686     for PYTHON_ABI in ${PYTHON_ABIS}; do
687     for dir in "${dirs[@]}"; do
688 arfrever 1.90 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
689 arfrever 1.85 done
690 arfrever 1.77 done
691 arfrever 1.85 }
692 arfrever 1.77
693 arfrever 1.82 # @FUNCTION: python_generate_wrapper_scripts
694     # @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
695     # @DESCRIPTION:
696     # Generate wrapper scripts. Existing files are overwritten only with --force option.
697     # If --respect-EPYTHON option is specified, then generated wrapper scripts will
698     # respect EPYTHON variable at run time.
699     python_generate_wrapper_scripts() {
700 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
701     die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
702     fi
703    
704 arfrever 1.87 _python_initialize_prefix_variables
705    
706     local eselect_python_option file force="0" quiet="0" PYTHON_ABI python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
707 arfrever 1.82
708     while (($#)); do
709     case "$1" in
710     -E|--respect-EPYTHON)
711     respect_EPYTHON="1"
712     ;;
713     -f|--force)
714     force="1"
715     ;;
716     -q|--quiet)
717     quiet="1"
718     ;;
719     --)
720 arfrever 1.87 shift
721 arfrever 1.82 break
722     ;;
723     -*)
724     die "${FUNCNAME}(): Unrecognized option '$1'"
725     ;;
726     *)
727     break
728     ;;
729     esac
730     shift
731     done
732    
733     if [[ "$#" -eq 0 ]]; then
734     die "${FUNCNAME}(): Missing arguments"
735     fi
736    
737     validate_PYTHON_ABIS
738 arfrever 1.88 for PYTHON_ABI in "${_CPYTHON2_SUPPORTED_ABIS[@]}"; do
739 arfrever 1.82 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
740     python2_enabled="1"
741     fi
742     done
743 arfrever 1.88 for PYTHON_ABI in "${_CPYTHON3_SUPPORTED_ABIS[@]}"; do
744 arfrever 1.82 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
745     python3_enabled="1"
746     fi
747     done
748    
749     if [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "1" ]]; then
750     eselect_python_option=
751     elif [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "0" ]]; then
752     eselect_python_option="--python2"
753     elif [[ "${python2_enabled}" == "0" && "${python3_enabled}" == "1" ]]; then
754     eselect_python_option="--python3"
755     else
756     die "${FUNCNAME}(): Unsupported environment"
757     fi
758    
759     for file in "$@"; do
760     if [[ -f "${file}" && "${force}" == "0" ]]; then
761     die "${FUNCNAME}(): '$1' already exists"
762     fi
763    
764     if [[ "${quiet}" == "0" ]]; then
765 arfrever 1.94 einfo "Generating '${file#${ED%/}}' wrapper script"
766 arfrever 1.82 fi
767    
768     cat << EOF > "${file}"
769     #!/usr/bin/env python
770 arfrever 1.94 # Gentoo '${file##*/}' wrapper script generated by python_generate_wrapper_scripts()
771 arfrever 1.82
772     import os
773     import re
774     import subprocess
775     import sys
776    
777     EPYTHON_re = re.compile(r"^python(\d+\.\d+)$")
778 arfrever 1.94 python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)")
779     python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
780 arfrever 1.82
781     EOF
782     if [[ "$?" != "0" ]]; then
783     die "${FUNCNAME}(): Generation of '$1' failed"
784     fi
785     if [[ "${respect_EPYTHON}" == "1" ]]; then
786     cat << EOF >> "${file}"
787     EPYTHON = os.environ.get("EPYTHON")
788     if EPYTHON:
789     EPYTHON_matched = EPYTHON_re.match(EPYTHON)
790     if EPYTHON_matched:
791     PYTHON_ABI = EPYTHON_matched.group(1)
792     else:
793     sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON)
794     sys.exit(1)
795     else:
796     try:
797 arfrever 1.87 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
798 arfrever 1.82 if eselect_process.wait() != 0:
799     raise ValueError
800     except (OSError, ValueError):
801     sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
802     sys.exit(1)
803    
804 arfrever 1.95 EPYTHON = eselect_process.stdout.read()
805 arfrever 1.94 if not isinstance(EPYTHON, str):
806 arfrever 1.82 # Python 3
807 arfrever 1.94 EPYTHON = EPYTHON.decode()
808 arfrever 1.95 EPYTHON = EPYTHON.rstrip("\n")
809 arfrever 1.82
810 arfrever 1.94 EPYTHON_matched = EPYTHON_re.match(EPYTHON)
811 arfrever 1.82 if EPYTHON_matched:
812     PYTHON_ABI = EPYTHON_matched.group(1)
813     else:
814 arfrever 1.95 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
815 arfrever 1.82 sys.exit(1)
816     EOF
817     if [[ "$?" != "0" ]]; then
818     die "${FUNCNAME}(): Generation of '$1' failed"
819     fi
820     else
821     cat << EOF >> "${file}"
822     try:
823 arfrever 1.87 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE)
824 arfrever 1.82 if eselect_process.wait() != 0:
825     raise ValueError
826     except (OSError, ValueError):
827     sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n")
828     sys.exit(1)
829    
830 arfrever 1.95 EPYTHON = eselect_process.stdout.read()
831 arfrever 1.94 if not isinstance(EPYTHON, str):
832 arfrever 1.82 # Python 3
833 arfrever 1.94 EPYTHON = EPYTHON.decode()
834 arfrever 1.95 EPYTHON = EPYTHON.rstrip("\n")
835 arfrever 1.82
836 arfrever 1.94 EPYTHON_matched = EPYTHON_re.match(EPYTHON)
837 arfrever 1.82 if EPYTHON_matched:
838     PYTHON_ABI = EPYTHON_matched.group(1)
839     else:
840 arfrever 1.95 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON)
841 arfrever 1.82 sys.exit(1)
842     EOF
843     if [[ "$?" != "0" ]]; then
844     die "${FUNCNAME}(): Generation of '$1' failed"
845     fi
846     fi
847     cat << EOF >> "${file}"
848    
849 arfrever 1.94 wrapper_script_path = os.path.realpath(sys.argv[0])
850     target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
851     os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
852     os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
853     if not os.path.exists(target_executable_path):
854     sys.stderr.write("'%s' does not exist\n" % target_executable_path)
855 arfrever 1.82 sys.exit(1)
856    
857 arfrever 1.94 target_executable = open(target_executable_path, "rb")
858     target_executable_first_line = target_executable.readline()
859     if not isinstance(target_executable_first_line, str):
860     # Python 3
861     target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
862    
863     python_shebang_matched = python_shebang_re.match(target_executable_first_line)
864     target_executable.close()
865    
866     if python_shebang_matched:
867     try:
868     python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON
869     os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
870     python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
871     del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
872     if python_verification_process.wait() != 0:
873     raise ValueError
874    
875     python_verification_output = python_verification_process.stdout.read()
876     if not isinstance(python_verification_output, str):
877     # Python 3
878     python_verification_output = python_verification_output.decode()
879    
880     if not python_verification_output_re.match(python_verification_output):
881     raise ValueError
882    
883     os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv)
884     except:
885     pass
886     if "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION" in os.environ:
887     del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
888    
889     os.execv(target_executable_path, sys.argv)
890 arfrever 1.82 EOF
891     if [[ "$?" != "0" ]]; then
892     die "${FUNCNAME}(): Generation of '$1' failed"
893     fi
894 arfrever 1.87 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
895 arfrever 1.82 done
896     }
897    
898 arfrever 1.85 # ================================================================================================
899 arfrever 1.95 # ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
900 arfrever 1.85 # ================================================================================================
901    
902     # @FUNCTION: python_set_active_version
903 arfrever 1.88 # @USAGE: <CPython_ABI|2|3>
904 betelgeuse 1.55 # @DESCRIPTION:
905 arfrever 1.88 # Set specified version of CPython as active version of Python.
906 arfrever 1.85 python_set_active_version() {
907 arfrever 1.95 if _python_package_supporting_installation_for_multiple_python_abis; then
908     die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
909 arfrever 1.88 fi
910    
911 arfrever 1.87 if [[ "$#" -ne 1 ]]; then
912 arfrever 1.85 die "${FUNCNAME}() requires 1 argument"
913     fi
914    
915 arfrever 1.90 _python_initial_sanity_checks
916    
917 arfrever 1.85 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
918     if ! _python_implementation && ! has_version "dev-lang/python:$1"; then
919     die "${FUNCNAME}(): 'dev-lang/python:$1' is not installed"
920     fi
921     export EPYTHON="$(PYTHON "$1")"
922     elif [[ "$1" == "2" ]]; then
923     if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
924     die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
925     fi
926     export EPYTHON="$(PYTHON -2)"
927     elif [[ "$1" == "3" ]]; then
928     if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
929     die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
930     fi
931     export EPYTHON="$(PYTHON -3)"
932     else
933     die "${FUNCNAME}(): Unrecognized argument '$1'"
934     fi
935    
936     # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
937     # so it does not need to be exported to subprocesses.
938     PYTHON_ABI="${EPYTHON#python}"
939     PYTHON_ABI="${PYTHON_ABI%%-*}"
940 arfrever 1.87
941 arfrever 1.90 _python_final_sanity_checks
942    
943 arfrever 1.87 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
944     PYTHON_REQUESTED_ACTIVE_VERSION="$1"
945 arfrever 1.85 }
946 betelgeuse 1.55
947 arfrever 1.85 # @FUNCTION: python_need_rebuild
948 arfrever 1.88 # @DESCRIPTION: Mark current package for rebuilding by python-updater after
949     # switching of active version of Python.
950 arfrever 1.85 python_need_rebuild() {
951 arfrever 1.95 if _python_package_supporting_installation_for_multiple_python_abis; then
952     die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
953 arfrever 1.90 fi
954    
955     export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
956 arfrever 1.85 }
957 betelgeuse 1.55
958 arfrever 1.85 # ================================================================================================
959     # ======================================= GETTER FUNCTIONS =======================================
960     # ================================================================================================
961 betelgeuse 1.55
962 arfrever 1.88 _PYTHON_ABI_EXTRACTION_COMMAND='import platform
963     import sys
964     sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
965     if platform.system()[:4] == "Java":
966     sys.stdout.write("-jython")'
967    
968     _python_get_implementation() {
969     if [[ "$#" -ne 1 ]]; then
970     die "${FUNCNAME}() requires 1 argument"
971     fi
972    
973     if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
974     echo "CPython"
975     elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
976     echo "Jython"
977     else
978     die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
979     fi
980     }
981    
982 arfrever 1.85 # @FUNCTION: PYTHON
983 arfrever 1.90 # @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
984 betelgeuse 1.55 # @DESCRIPTION:
985 arfrever 1.88 # Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
986 arfrever 1.85 # is ommitted, then PYTHON_ABI environment variable must be set and is used.
987     # If -2 option is specified, then active version of Python 2 is used.
988     # If -3 option is specified, then active version of Python 3 is used.
989     # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
990 arfrever 1.90 # -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
991 arfrever 1.85 # If --ABI option is specified, then only specified Python ABI is printed instead of
992 arfrever 1.88 # filename of Python interpreter.
993     # If --absolute-path option is specified, then absolute path to Python interpreter is printed.
994 arfrever 1.85 # --ABI and --absolute-path options cannot be specified simultaneously.
995     PYTHON() {
996 arfrever 1.90 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
997 betelgeuse 1.55
998 arfrever 1.85 while (($#)); do
999     case "$1" in
1000     -2)
1001     python2="1"
1002     ;;
1003     -3)
1004     python3="1"
1005     ;;
1006     --ABI)
1007     ABI_output="1"
1008     ;;
1009     -a|--absolute-path)
1010     absolute_path_output="1"
1011     ;;
1012     -f|--final-ABI)
1013     final_ABI="1"
1014     ;;
1015     --)
1016 arfrever 1.87 shift
1017 arfrever 1.85 break
1018     ;;
1019     -*)
1020     die "${FUNCNAME}(): Unrecognized option '$1'"
1021     ;;
1022     *)
1023     break
1024     ;;
1025     esac
1026     shift
1027     done
1028 betelgeuse 1.55
1029 arfrever 1.85 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
1030     die "${FUNCNAME}(): '--ABI and '--absolute-path' options cannot be specified simultaneously"
1031     fi
1032 arfrever 1.74
1033 arfrever 1.90 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
1034     die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
1035 arfrever 1.85 fi
1036 betelgeuse 1.55
1037 arfrever 1.85 if [[ "$#" -eq 0 ]]; then
1038 arfrever 1.90 if [[ "${final_ABI}" == "1" ]]; then
1039 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1040     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1041 arfrever 1.86 fi
1042 arfrever 1.85 validate_PYTHON_ABIS
1043 arfrever 1.88 PYTHON_ABI="${PYTHON_ABIS##* }"
1044 arfrever 1.85 elif [[ "${python2}" == "1" ]]; then
1045 arfrever 1.89 PYTHON_ABI="$(eselect python show --python2 --ABI)"
1046 arfrever 1.88 if [[ -z "${PYTHON_ABI}" ]]; then
1047 arfrever 1.85 die "${FUNCNAME}(): Active Python 2 interpreter not set"
1048 arfrever 1.89 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1049 arfrever 1.85 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1050     fi
1051     elif [[ "${python3}" == "1" ]]; then
1052 arfrever 1.89 PYTHON_ABI="$(eselect python show --python3 --ABI)"
1053 arfrever 1.88 if [[ -z "${PYTHON_ABI}" ]]; then
1054 arfrever 1.85 die "${FUNCNAME}(): Active Python 3 interpreter not set"
1055 arfrever 1.89 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1056 arfrever 1.85 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1057 betelgeuse 1.55 fi
1058 arfrever 1.95 elif ! _python_package_supporting_installation_for_multiple_python_abis; then
1059 arfrever 1.90 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1060 arfrever 1.88 elif [[ -z "${PYTHON_ABI}" ]]; then
1061 arfrever 1.94 die "${FUNCNAME}(): Invalid usage: ${FUNCNAME}() should be used in ABI-specific local scope"
1062 arfrever 1.85 fi
1063     elif [[ "$#" -eq 1 ]]; then
1064     if [[ "${final_ABI}" == "1" ]]; then
1065     die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1066     fi
1067     if [[ "${python2}" == "1" ]]; then
1068     die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously"
1069     fi
1070     if [[ "${python3}" == "1" ]]; then
1071     die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously"
1072 betelgeuse 1.55 fi
1073 arfrever 1.88 PYTHON_ABI="$1"
1074 arfrever 1.85 else
1075     die "${FUNCNAME}(): Invalid usage"
1076 betelgeuse 1.55 fi
1077 hawking 1.46
1078 arfrever 1.85 if [[ "${ABI_output}" == "1" ]]; then
1079 arfrever 1.88 echo -n "${PYTHON_ABI}"
1080 arfrever 1.85 return
1081     else
1082 arfrever 1.88 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1083     python_interpreter="python${PYTHON_ABI}"
1084     elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1085     python_interpreter="jython-${PYTHON_ABI%-jython}"
1086     fi
1087    
1088     if [[ "${absolute_path_output}" == "1" ]]; then
1089     echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1090     else
1091     echo -n "${python_interpreter}"
1092     fi
1093 arfrever 1.85 fi
1094 hawking 1.46
1095 arfrever 1.85 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then
1096     echo -n "-${ABI}"
1097     fi
1098 hawking 1.52 }
1099    
1100 arfrever 1.88 # @FUNCTION: python_get_implementation
1101     # @USAGE: [-f|--final-ABI]
1102     # @DESCRIPTION:
1103     # Print name of Python implementation.
1104     # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1105     python_get_implementation() {
1106     local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1107    
1108     while (($#)); do
1109     case "$1" in
1110     -f|--final-ABI)
1111     final_ABI="1"
1112     ;;
1113     -*)
1114     die "${FUNCNAME}(): Unrecognized option '$1'"
1115     ;;
1116     *)
1117     die "${FUNCNAME}(): Invalid usage"
1118     ;;
1119     esac
1120     shift
1121     done
1122    
1123     if [[ "${final_ABI}" == "1" ]]; then
1124 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1125     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1126     fi
1127 arfrever 1.88 PYTHON_ABI="$(PYTHON -f --ABI)"
1128     elif [[ -z "${PYTHON_ABI}" ]]; then
1129 arfrever 1.90 PYTHON_ABI="$(PYTHON --ABI)"
1130 arfrever 1.88 fi
1131    
1132     echo "$(_python_get_implementation "${PYTHON_ABI}")"
1133     }
1134    
1135     # @FUNCTION: python_get_implementational_package
1136     # @USAGE: [-f|--final-ABI]
1137     # @DESCRIPTION:
1138     # Print category, name and slot of package providing Python implementation.
1139     # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1140     python_get_implementational_package() {
1141     local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1142    
1143     while (($#)); do
1144     case "$1" in
1145     -f|--final-ABI)
1146     final_ABI="1"
1147     ;;
1148     -*)
1149     die "${FUNCNAME}(): Unrecognized option '$1'"
1150     ;;
1151     *)
1152     die "${FUNCNAME}(): Invalid usage"
1153     ;;
1154     esac
1155     shift
1156     done
1157    
1158     if [[ "${final_ABI}" == "1" ]]; then
1159 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1160     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1161     fi
1162 arfrever 1.88 PYTHON_ABI="$(PYTHON -f --ABI)"
1163     elif [[ -z "${PYTHON_ABI}" ]]; then
1164 arfrever 1.90 PYTHON_ABI="$(PYTHON --ABI)"
1165 arfrever 1.88 fi
1166    
1167     if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1168     echo "dev-lang/python:${PYTHON_ABI}"
1169     elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1170     echo "dev-java/jython:${PYTHON_ABI%-jython}"
1171     fi
1172     }
1173    
1174 arfrever 1.56 # @FUNCTION: python_get_includedir
1175 arfrever 1.86 # @USAGE: [-f|--final-ABI]
1176 arfrever 1.56 # @DESCRIPTION:
1177 arfrever 1.87 # Print path to Python include directory.
1178 arfrever 1.86 # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1179 arfrever 1.56 python_get_includedir() {
1180 arfrever 1.88 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1181 arfrever 1.86
1182     while (($#)); do
1183     case "$1" in
1184     -f|--final-ABI)
1185     final_ABI="1"
1186     ;;
1187     -*)
1188     die "${FUNCNAME}(): Unrecognized option '$1'"
1189     ;;
1190     *)
1191     die "${FUNCNAME}(): Invalid usage"
1192     ;;
1193     esac
1194     shift
1195     done
1196    
1197     if [[ "${final_ABI}" == "1" ]]; then
1198 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1199     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1200     fi
1201 arfrever 1.88 PYTHON_ABI="$(PYTHON -f --ABI)"
1202     elif [[ -z "${PYTHON_ABI}" ]]; then
1203 arfrever 1.90 PYTHON_ABI="$(PYTHON --ABI)"
1204 arfrever 1.88 fi
1205    
1206     if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1207 arfrever 1.56 echo "/usr/include/python${PYTHON_ABI}"
1208 arfrever 1.88 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1209     echo "/usr/share/jython-${PYTHON_ABI%-jython}/Include"
1210 arfrever 1.56 fi
1211     }
1212    
1213 pythonhead 1.43 # @FUNCTION: python_get_libdir
1214 arfrever 1.86 # @USAGE: [-f|--final-ABI]
1215 pythonhead 1.43 # @DESCRIPTION:
1216 arfrever 1.87 # Print path to Python library directory.
1217 arfrever 1.86 # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1218 pythonhead 1.43 python_get_libdir() {
1219 arfrever 1.88 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1220 arfrever 1.86
1221     while (($#)); do
1222     case "$1" in
1223     -f|--final-ABI)
1224     final_ABI="1"
1225     ;;
1226     -*)
1227     die "${FUNCNAME}(): Unrecognized option '$1'"
1228     ;;
1229     *)
1230     die "${FUNCNAME}(): Invalid usage"
1231     ;;
1232     esac
1233     shift
1234     done
1235    
1236     if [[ "${final_ABI}" == "1" ]]; then
1237 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1238     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1239     fi
1240 arfrever 1.88 PYTHON_ABI="$(PYTHON -f --ABI)"
1241     elif [[ -z "${PYTHON_ABI}" ]]; then
1242 arfrever 1.90 PYTHON_ABI="$(PYTHON --ABI)"
1243 arfrever 1.88 fi
1244    
1245     if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1246 arfrever 1.56 echo "/usr/$(get_libdir)/python${PYTHON_ABI}"
1247 arfrever 1.88 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1248     echo "/usr/share/jython-${PYTHON_ABI%-jython}/Lib"
1249 arfrever 1.56 fi
1250 pythonhead 1.42 }
1251    
1252 pythonhead 1.43 # @FUNCTION: python_get_sitedir
1253 arfrever 1.86 # @USAGE: [-f|--final-ABI]
1254 pythonhead 1.43 # @DESCRIPTION:
1255 arfrever 1.87 # Print path to Python site-packages directory.
1256 arfrever 1.86 # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1257 pythonhead 1.43 python_get_sitedir() {
1258 arfrever 1.86 local options=()
1259    
1260     while (($#)); do
1261     case "$1" in
1262     -f|--final-ABI)
1263 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1264     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1265     fi
1266 arfrever 1.86 options+=("$1")
1267     ;;
1268     -*)
1269     die "${FUNCNAME}(): Unrecognized option '$1'"
1270     ;;
1271     *)
1272     die "${FUNCNAME}(): Invalid usage"
1273     ;;
1274     esac
1275     shift
1276     done
1277    
1278     echo "$(python_get_libdir "${options[@]}")/site-packages"
1279 pythonhead 1.42 }
1280    
1281 arfrever 1.87 # @FUNCTION: python_get_library
1282     # @USAGE: [-f|--final-ABI] [-l|--linker-option]
1283     # @DESCRIPTION:
1284     # Print path to Python library.
1285     # If --linker-option is specified, then "-l${library}" linker option is printed.
1286     # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1287     python_get_library() {
1288 arfrever 1.88 local final_ABI="0" linker_option="0" PYTHON_ABI="${PYTHON_ABI}"
1289 arfrever 1.87
1290     while (($#)); do
1291     case "$1" in
1292     -f|--final-ABI)
1293     final_ABI="1"
1294     ;;
1295     -l|--linker-option)
1296     linker_option="1"
1297     ;;
1298     -*)
1299     die "${FUNCNAME}(): Unrecognized option '$1'"
1300     ;;
1301     *)
1302     die "${FUNCNAME}(): Invalid usage"
1303     ;;
1304     esac
1305     shift
1306     done
1307    
1308     if [[ "${final_ABI}" == "1" ]]; then
1309 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1310     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1311     fi
1312 arfrever 1.88 PYTHON_ABI="$(PYTHON -f --ABI)"
1313     elif [[ -z "${PYTHON_ABI}" ]]; then
1314 arfrever 1.90 PYTHON_ABI="$(PYTHON --ABI)"
1315 arfrever 1.87 fi
1316    
1317 arfrever 1.88 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1318     if [[ "${linker_option}" == "1" ]]; then
1319     echo "-lpython${PYTHON_ABI}"
1320     else
1321     echo "/usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
1322     fi
1323     elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1324     die "${FUNCNAME}(): Jython does not have shared library"
1325 arfrever 1.87 fi
1326     }
1327    
1328     # @FUNCTION: python_get_version
1329 arfrever 1.92 # @USAGE: [-f|--final-ABI] [--full] [--major] [--minor] [--micro]
1330 arfrever 1.87 # @DESCRIPTION:
1331     # Print Python version.
1332 arfrever 1.92 # --full, --major, --minor and --micro options cannot be specified simultaneously.
1333     # If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
1334 arfrever 1.87 # If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1335     python_get_version() {
1336 arfrever 1.92 local final_ABI="0" full="0" major="0" minor="0" micro="0" python_command
1337 arfrever 1.87
1338     while (($#)); do
1339     case "$1" in
1340     -f|--final-ABI)
1341     final_ABI="1"
1342     ;;
1343 arfrever 1.92 --full)
1344     full="1"
1345     ;;
1346 arfrever 1.87 --major)
1347     major="1"
1348     ;;
1349     --minor)
1350     minor="1"
1351     ;;
1352     --micro)
1353     micro="1"
1354     ;;
1355     -*)
1356     die "${FUNCNAME}(): Unrecognized option '$1'"
1357     ;;
1358     *)
1359     die "${FUNCNAME}(): Invalid usage"
1360     ;;
1361     esac
1362     shift
1363     done
1364    
1365 arfrever 1.92 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
1366     die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
1367 arfrever 1.87 fi
1368    
1369 arfrever 1.92 if [[ "${full}" == "1" ]]; then
1370     python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))"
1371     elif [[ "${major}" == "1" ]]; then
1372 arfrever 1.87 python_command="from sys import version_info; print(version_info[0])"
1373     elif [[ "${minor}" == "1" ]]; then
1374     python_command="from sys import version_info; print(version_info[1])"
1375     elif [[ "${micro}" == "1" ]]; then
1376     python_command="from sys import version_info; print(version_info[2])"
1377     else
1378 arfrever 1.92 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
1379     if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1380     echo "${PYTHON_ABI}"
1381     elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1382     echo "${PYTHON_ABI%-jython}"
1383     fi
1384     return
1385     fi
1386 arfrever 1.88 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
1387 arfrever 1.87 fi
1388    
1389     if [[ "${final_ABI}" == "1" ]]; then
1390 arfrever 1.95 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1391     die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1392     fi
1393 arfrever 1.87 "$(PYTHON -f)" -c "${python_command}"
1394     else
1395 arfrever 1.90 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
1396 arfrever 1.87 fi
1397     }
1398    
1399 arfrever 1.85 # ================================================================================================
1400     # =================================== MISCELLANEOUS FUNCTIONS ====================================
1401     # ================================================================================================
1402    
1403     _python_implementation() {
1404     if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
1405     return 0
1406 arfrever 1.88 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
1407     return 0
1408 arfrever 1.85 else
1409     return 1
1410     fi
1411     }
1412    
1413 arfrever 1.95 _python_package_supporting_installation_for_multiple_python_abis() {
1414     if [[ "${EBUILD_PHASE}" == "depend" ]]; then
1415     die "${FUNCNAME}() cannot be used in global scope"
1416     fi
1417    
1418     if has "${EAPI:-0}" 0 1 2 3 4; then
1419     if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
1420     return 0
1421     else
1422     return 1
1423     fi
1424     else
1425     die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
1426     fi
1427     }
1428    
1429 arfrever 1.87 _python_initialize_prefix_variables() {
1430     if has "${EAPI:-0}" 0 1 2; then
1431     if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
1432     EROOT="${ROOT%/}${EPREFIX}/"
1433     fi
1434     if [[ -n "${D}" && -z "${ED}" ]]; then
1435     ED="${D%/}${EPREFIX}/"
1436     fi
1437     fi
1438     }
1439    
1440 arfrever 1.90 unset PYTHON_SANITY_CHECKS
1441    
1442     _python_initial_sanity_checks() {
1443     if [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1444     # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
1445     if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
1446     eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
1447     eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1448     die "'${EPREFIX}/usr/bin/python' is not valid symlink"
1449     fi
1450     if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
1451     eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
1452     eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
1453     die "'${EPREFIX}/usr/bin/python-config' is not valid script"
1454     fi
1455     fi
1456     }
1457    
1458     _python_final_sanity_checks() {
1459     if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS="* ]]; then
1460     local PYTHON_ABI="${PYTHON_ABI}"
1461     for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
1462     # Ensure that appropriate version of Python is installed.
1463     if ! has_version "$(python_get_implementational_package)"; then
1464     die "$(python_get_implementational_package) is not installed"
1465     fi
1466    
1467     # Ensure that EPYTHON variable is respected.
1468     if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
1469     eerror "python: '$(type -p python)'"
1470     eerror "ABI: '${ABI}'"
1471     eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
1472     eerror "EPYTHON: '$(PYTHON)'"
1473     eerror "PYTHON_ABI: '${PYTHON_ABI}'"
1474     eerror "Version of enabled Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
1475     die "'python' does not respect EPYTHON variable"
1476     fi
1477     done
1478     fi
1479     PYTHON_SANITY_CHECKS="1"
1480     }
1481    
1482     _python_set_color_variables() {
1483     if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
1484     _BOLD=$'\e[1m'
1485     _RED=$'\e[1;31m'
1486     _GREEN=$'\e[1;32m'
1487     _BLUE=$'\e[1;34m'
1488     _CYAN=$'\e[1;36m'
1489     _NORMAL=$'\e[0m'
1490     else
1491     _BOLD=
1492     _RED=
1493     _GREEN=
1494     _BLUE=
1495     _CYAN=
1496     _NORMAL=
1497     fi
1498     }
1499    
1500 arfrever 1.85 # @FUNCTION: python_convert_shebangs
1501     # @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_version> <file|directory> [files|directories]
1502 dev-zero 1.33 # @DESCRIPTION:
1503 arfrever 1.85 # Convert shebangs in specified files. Directories can be specified only with --recursive option.
1504     python_convert_shebangs() {
1505     local argument file files=() only_executables="0" python_version quiet="0" recursive="0"
1506    
1507     while (($#)); do
1508     case "$1" in
1509     -r|--recursive)
1510     recursive="1"
1511     ;;
1512     -q|--quiet)
1513     quiet="1"
1514     ;;
1515     -x|--only-executables)
1516     only_executables="1"
1517     ;;
1518     --)
1519 arfrever 1.87 shift
1520 arfrever 1.85 break
1521     ;;
1522     -*)
1523     die "${FUNCNAME}(): Unrecognized option '$1'"
1524     ;;
1525     *)
1526     break
1527     ;;
1528     esac
1529     shift
1530     done
1531    
1532     if [[ "$#" -eq 0 ]]; then
1533     die "${FUNCNAME}(): Missing Python version and files or directories"
1534     elif [[ "$#" -eq 1 ]]; then
1535     die "${FUNCNAME}(): Missing files or directories"
1536 liquidx 1.1 fi
1537 arfrever 1.85
1538     python_version="$1"
1539     shift
1540    
1541     for argument in "$@"; do
1542     if [[ ! -e "${argument}" ]]; then
1543     die "${FUNCNAME}(): '${argument}' does not exist"
1544     elif [[ -f "${argument}" ]]; then
1545     files+=("${argument}")
1546     elif [[ -d "${argument}" ]]; then
1547     if [[ "${recursive}" == "1" ]]; then
1548 arfrever 1.95 while read -d $'\0' -r file; do
1549     files+=("${file}")
1550     done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
1551 arfrever 1.85 else
1552     die "${FUNCNAME}(): '${argument}' is not a regular file"
1553     fi
1554     else
1555     die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
1556     fi
1557     done
1558    
1559     for file in "${files[@]}"; do
1560     file="${file#./}"
1561     [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
1562    
1563     if [[ "$(head -n1 "${file}")" =~ ^'#!'.*python ]]; then
1564 arfrever 1.94 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
1565    
1566 arfrever 1.85 if [[ "${quiet}" == "0" ]]; then
1567     einfo "Converting shebang in '${file}'"
1568     fi
1569 arfrever 1.94
1570 arfrever 1.85 sed -e "1s/python\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?/python${python_version}/" -i "${file}" || die "Conversion of shebang in '${file}' failed"
1571    
1572     # Delete potential whitespace after "#!".
1573     sed -e '1s/\(^#!\)[[:space:]]*/\1/' -i "${file}" || die "sed '${file}' failed"
1574     fi
1575     done
1576 liquidx 1.1 }
1577    
1578 arfrever 1.94 # @FUNCTION: python_clean_sitedirs
1579     # @DESCRIPTION:
1580     # Delete needless files in site-packages directories in ${ED}.
1581     python_clean_sitedirs() {
1582     _python_initialize_prefix_variables
1583    
1584     find "${ED}"usr/$(get_libdir)/python*/site-packages "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
1585     }
1586    
1587 arfrever 1.87 # ================================================================================================
1588     # ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
1589     # ================================================================================================
1590    
1591     # @ECLASS-VARIABLE: PYTHON_TEST_VERBOSITY
1592     # @DESCRIPTION:
1593     # User-configurable verbosity of tests of Python modules.
1594     # Supported values: 0, 1, 2, 3, 4.
1595     PYTHON_TEST_VERBOSITY="${PYTHON_TEST_VERBOSITY:-1}"
1596    
1597 arfrever 1.92 _python_test_hook() {
1598     if [[ "$#" -ne 1 ]]; then
1599     die "${FUNCNAME}() requires 1 argument"
1600     fi
1601    
1602 arfrever 1.95 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then
1603 arfrever 1.92 "${FUNCNAME[3]}_$1_hook"
1604     fi
1605     }
1606    
1607 arfrever 1.87 # @FUNCTION: python_execute_nosetests
1608     # @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1609     # @DESCRIPTION:
1610 arfrever 1.95 # Execute nosetests for all enabled Python ABIs.
1611     # In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1612     # python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
1613 arfrever 1.87 python_execute_nosetests() {
1614 arfrever 1.90 _python_set_color_variables
1615    
1616 arfrever 1.87 local PYTHONPATH_template= separate_build_dirs=
1617    
1618     while (($#)); do
1619     case "$1" in
1620     -P|--PYTHONPATH)
1621     PYTHONPATH_template="$2"
1622     shift
1623     ;;
1624     -s|--separate-build-dirs)
1625     separate_build_dirs="1"
1626     ;;
1627     --)
1628     shift
1629     break
1630     ;;
1631     -*)
1632     die "${FUNCNAME}(): Unrecognized option '$1'"
1633     ;;
1634     *)
1635     break
1636     ;;
1637     esac
1638     shift
1639     done
1640    
1641     python_test_function() {
1642     local evaluated_PYTHONPATH=
1643    
1644     if [[ -n "${PYTHONPATH_template}" ]]; then
1645     evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")"
1646     if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1647     unset evaluated_PYTHONPATH
1648     fi
1649     fi
1650    
1651 arfrever 1.92 _python_test_hook pre
1652    
1653 arfrever 1.87 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1654 arfrever 1.90 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1655 arfrever 1.92 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
1656 arfrever 1.87 else
1657 arfrever 1.90 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
1658 arfrever 1.92 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
1659 arfrever 1.87 fi
1660 arfrever 1.92
1661     _python_test_hook post
1662 arfrever 1.87 }
1663 arfrever 1.95 if _python_package_supporting_installation_for_multiple_python_abis; then
1664 arfrever 1.87 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1665     else
1666     if [[ -n "${separate_build_dirs}" ]]; then
1667     die "${FUNCNAME}(): Invalid usage"
1668     fi
1669 arfrever 1.88 python_test_function "$@" || die "Testing failed"
1670 arfrever 1.87 fi
1671 arfrever 1.88
1672     unset -f python_test_function
1673 arfrever 1.87 }
1674    
1675     # @FUNCTION: python_execute_py.test
1676     # @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1677     # @DESCRIPTION:
1678 arfrever 1.95 # Execute py.test for all enabled Python ABIs.
1679     # In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
1680     # python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
1681 arfrever 1.87 python_execute_py.test() {
1682 arfrever 1.90 _python_set_color_variables
1683    
1684 arfrever 1.87 local PYTHONPATH_template= separate_build_dirs=
1685    
1686     while (($#)); do
1687     case "$1" in
1688     -P|--PYTHONPATH)
1689     PYTHONPATH_template="$2"
1690     shift
1691     ;;
1692     -s|--separate-build-dirs)
1693     separate_build_dirs="1"
1694     ;;
1695     --)
1696     shift
1697     break
1698     ;;
1699     -*)
1700     die "${FUNCNAME}(): Unrecognized option '$1'"
1701     ;;
1702     *)
1703     break
1704     ;;
1705     esac
1706     shift
1707     done
1708    
1709     python_test_function() {
1710     local evaluated_PYTHONPATH=
1711    
1712     if [[ -n "${PYTHONPATH_template}" ]]; then
1713     evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")"
1714     if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1715     unset evaluated_PYTHONPATH
1716     fi
1717     fi
1718    
1719 arfrever 1.92 _python_test_hook pre
1720    
1721 arfrever 1.87 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1722 arfrever 1.90 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
1723 arfrever 1.92 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
1724 arfrever 1.87 else
1725 arfrever 1.90 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
1726 arfrever 1.92 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
1727 arfrever 1.87 fi
1728 arfrever 1.92
1729     _python_test_hook post
1730 arfrever 1.87 }
1731 arfrever 1.95 if _python_package_supporting_installation_for_multiple_python_abis; then
1732 arfrever 1.87 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1733     else
1734     if [[ -n "${separate_build_dirs}" ]]; then
1735     die "${FUNCNAME}(): Invalid usage"
1736     fi
1737 arfrever 1.88 python_test_function "$@" || die "Testing failed"
1738 arfrever 1.87 fi
1739 arfrever 1.88
1740     unset -f python_test_function
1741 arfrever 1.87 }
1742    
1743     # @FUNCTION: python_execute_trial
1744     # @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
1745     # @DESCRIPTION:
1746 arfrever 1.95 # Execute trial for all enabled Python ABIs.
1747     # In ebuilds of packages supporting installation for multiple Python ABIs, this function
1748 arfrever 1.92 # calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
1749 arfrever 1.87 python_execute_trial() {
1750 arfrever 1.90 _python_set_color_variables
1751    
1752 arfrever 1.87 local PYTHONPATH_template= separate_build_dirs=
1753    
1754     while (($#)); do
1755     case "$1" in
1756     -P|--PYTHONPATH)
1757     PYTHONPATH_template="$2"
1758     shift
1759     ;;
1760     -s|--separate-build-dirs)
1761     separate_build_dirs="1"
1762     ;;
1763     --)
1764     shift
1765     break
1766     ;;
1767     -*)
1768     die "${FUNCNAME}(): Unrecognized option '$1'"
1769     ;;
1770     *)
1771     break
1772     ;;
1773     esac
1774     shift
1775     done
1776    
1777     python_test_function() {
1778     local evaluated_PYTHONPATH=
1779    
1780     if [[ -n "${PYTHONPATH_template}" ]]; then
1781     evaluated_PYTHONPATH="$(eval echo -n "${PYTHONPATH_template}")"
1782     if [[ ! -e "${evaluated_PYTHONPATH}" ]]; then
1783     unset evaluated_PYTHONPATH
1784     fi
1785     fi
1786    
1787 arfrever 1.92 _python_test_hook pre
1788    
1789 arfrever 1.87 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
1790 arfrever 1.90 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1791 arfrever 1.92 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
1792 arfrever 1.87 else
1793 arfrever 1.90 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
1794 arfrever 1.92 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
1795 arfrever 1.87 fi
1796 arfrever 1.92
1797     _python_test_hook post
1798 arfrever 1.87 }
1799 arfrever 1.95 if _python_package_supporting_installation_for_multiple_python_abis; then
1800 arfrever 1.87 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
1801     else
1802     if [[ -n "${separate_build_dirs}" ]]; then
1803     die "${FUNCNAME}(): Invalid usage"
1804     fi
1805 arfrever 1.88 python_test_function "$@" || die "Testing failed"
1806 arfrever 1.56 fi
1807 arfrever 1.88
1808     unset -f python_test_function
1809 arfrever 1.85 }
1810 arfrever 1.56
1811 arfrever 1.85 # ================================================================================================
1812     # ======================= FUNCTIONS FOR HANDLING OF BYTE-COMPILED MODULES ========================
1813     # ================================================================================================
1814 hawking 1.37
1815 arfrever 1.85 # @FUNCTION: python_enable_pyc
1816     # @DESCRIPTION:
1817     # Tell Python to automatically recompile modules to .pyc/.pyo if the
1818     # timestamps/version stamps have changed.
1819     python_enable_pyc() {
1820     unset PYTHONDONTWRITEBYTECODE
1821     }
1822 hawking 1.37
1823 arfrever 1.85 # @FUNCTION: python_disable_pyc
1824     # @DESCRIPTION:
1825     # Tell Python not to automatically recompile modules to .pyc/.pyo
1826     # even if the timestamps/version stamps do not match. This is done
1827     # to protect sandbox.
1828     python_disable_pyc() {
1829     export PYTHONDONTWRITEBYTECODE="1"
1830 liquidx 1.1 }
1831    
1832 dev-zero 1.33 # @FUNCTION: python_mod_optimize
1833 arfrever 1.56 # @USAGE: [options] [directory|file]
1834 dev-zero 1.33 # @DESCRIPTION:
1835 arfrever 1.56 # If no arguments supplied, it will recompile not recursively all modules
1836     # under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages).
1837 liquidx 1.1 #
1838 dev-zero 1.33 # If supplied with arguments, it will recompile all modules recursively
1839 arfrever 1.56 # in the supplied directory.
1840 dev-zero 1.33 #
1841 arfrever 1.56 # Options passed to this function are passed to compileall.py.
1842 hawking 1.39 #
1843 arfrever 1.92 # This function can be used only in pkg_postinst() phase.
1844 liquidx 1.1 python_mod_optimize() {
1845 arfrever 1.87 _python_initialize_prefix_variables
1846    
1847 arfrever 1.56 # Check if phase is pkg_postinst().
1848 arfrever 1.95 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
1849 arfrever 1.56
1850 arfrever 1.95 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
1851 arfrever 1.90 local dir file options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=()
1852 hawking 1.37
1853 arfrever 1.56 # Strip trailing slash from ROOT.
1854 arfrever 1.87 root="${EROOT%/}"
1855 arfrever 1.56
1856     # Respect ROOT and options passed to compileall.py.
1857     while (($#)); do
1858     case "$1" in
1859     -l|-f|-q)
1860     options+=("$1")
1861     ;;
1862     -d|-x)
1863     options+=("$1" "$2")
1864     shift
1865     ;;
1866     -*)
1867 arfrever 1.87 ewarn "${FUNCNAME}(): Ignoring option '$1'"
1868 arfrever 1.56 ;;
1869     *)
1870 arfrever 1.87 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
1871     die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories"
1872 arfrever 1.56 elif [[ "$1" =~ ^/ ]]; then
1873     if [[ -d "${root}/$1" ]]; then
1874     other_dirs+=("${root}/$1")
1875     elif [[ -f "${root}/$1" ]]; then
1876     other_files+=("${root}/$1")
1877     elif [[ -e "${root}/$1" ]]; then
1878     ewarn "'${root}/$1' is not a file or a directory!"
1879     else
1880 arfrever 1.84 ewarn "'${root}/$1' does not exist!"
1881 arfrever 1.56 fi
1882     else
1883 arfrever 1.90 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
1884 arfrever 1.62 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
1885 arfrever 1.56 site_packages_dirs+=("$1")
1886     break
1887 arfrever 1.62 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
1888 arfrever 1.56 site_packages_files+=("$1")
1889     break
1890 arfrever 1.62 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
1891 arfrever 1.56 ewarn "'$1' is not a file or a directory!"
1892     else
1893 arfrever 1.84 ewarn "'$1' does not exist!"
1894 arfrever 1.56 fi
1895     done
1896     fi
1897     ;;
1898     esac
1899     shift
1900     done
1901 hawking 1.37
1902 arfrever 1.56 # Set additional options.
1903     options+=("-q")
1904 liquidx 1.13
1905 arfrever 1.90 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
1906 arfrever 1.56 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then
1907     return_code="0"
1908 arfrever 1.88 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1909 arfrever 1.56 if ((${#site_packages_dirs[@]})); then
1910     for dir in "${site_packages_dirs[@]}"; do
1911 arfrever 1.62 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}")
1912 arfrever 1.56 done
1913 arfrever 1.62 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1"
1914 arfrever 1.88 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1915     "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1"
1916     fi
1917 arfrever 1.56 fi
1918     if ((${#site_packages_files[@]})); then
1919     for file in "${site_packages_files[@]}"; do
1920 arfrever 1.62 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}")
1921 arfrever 1.56 done
1922 arfrever 1.62 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1"
1923 arfrever 1.88 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then
1924     "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1"
1925     fi
1926 hawking 1.49 fi
1927 arfrever 1.56 eend "${return_code}"
1928     fi
1929     unset site_packages_absolute_dirs site_packages_absolute_files
1930     done
1931    
1932 arfrever 1.86 # Restore previous value of PYTHON_ABI.
1933     if [[ -n "${previous_PYTHON_ABI}" ]]; then
1934     PYTHON_ABI="${previous_PYTHON_ABI}"
1935     else
1936     unset PYTHON_ABI
1937     fi
1938 hawking 1.36
1939 arfrever 1.56 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
1940     return_code="0"
1941 arfrever 1.89 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)"
1942 arfrever 1.56 if ((${#other_dirs[@]})); then
1943 arfrever 1.90 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1"
1944     if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then
1945     "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
1946 arfrever 1.88 fi
1947 arfrever 1.56 fi
1948     if ((${#other_files[@]})); then
1949 arfrever 1.90 "$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1"
1950     if [[ "$(_python_get_implementation "${PYTHON_ABI-$(PYTHON --ABI)}")" != "Jython" ]]; then
1951     "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1"
1952 arfrever 1.88 fi
1953 arfrever 1.56 fi
1954     eend "${return_code}"
1955     fi
1956 pythonhead 1.7 else
1957 arfrever 1.63 local myroot mydirs=() myfiles=() myopts=() return_code="0"
1958 arfrever 1.56
1959     # strip trailing slash
1960 arfrever 1.87 myroot="${EROOT%/}"
1961 arfrever 1.56
1962     # respect ROOT and options passed to compileall.py
1963     while (($#)); do
1964     case "$1" in
1965     -l|-f|-q)
1966     myopts+=("$1")
1967     ;;
1968     -d|-x)
1969     myopts+=("$1" "$2")
1970     shift
1971     ;;
1972     -*)
1973 arfrever 1.87 ewarn "${FUNCNAME}(): Ignoring option '$1'"
1974 arfrever 1.56 ;;
1975     *)
1976     if [[ -d "${myroot}"/$1 ]]; then
1977     mydirs+=("${myroot}/$1")
1978     elif [[ -f "${myroot}"/$1 ]]; then
1979     # Files are passed to python_mod_compile which is ROOT-aware
1980     myfiles+=("$1")
1981     elif [[ -e "${myroot}/$1" ]]; then
1982     ewarn "${myroot}/$1 is not a file or directory!"
1983     else
1984 arfrever 1.84 ewarn "${myroot}/$1 does not exist!"
1985 arfrever 1.56 fi
1986     ;;
1987     esac
1988     shift
1989     done
1990    
1991     # set additional opts
1992     myopts+=(-q)
1993 pythonhead 1.7
1994 arfrever 1.89 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
1995 arfrever 1.56 if ((${#mydirs[@]})); then
1996 arfrever 1.90 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
1997     "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
1998 arfrever 1.56 fi
1999 pythonhead 1.7
2000 arfrever 1.56 if ((${#myfiles[@]})); then
2001     python_mod_compile "${myfiles[@]}"
2002     fi
2003 hawking 1.36
2004 arfrever 1.63 eend "${return_code}"
2005 hawking 1.36 fi
2006 liquidx 1.1 }
2007    
2008 dev-zero 1.33 # @FUNCTION: python_mod_cleanup
2009 arfrever 1.79 # @USAGE: [directory|file]
2010 dev-zero 1.33 # @DESCRIPTION:
2011 arfrever 1.79 # Run with optional arguments, where arguments are Python modules. If none given,
2012     # it will look in /usr/lib/python[0-9].[0-9].
2013 dev-zero 1.33 #
2014 arfrever 1.56 # It will recursively scan all compiled Python modules in the directories and
2015     # determine if they are orphaned (i.e. their corresponding .py files are missing.)
2016     # If they are, then it will remove their corresponding .pyc and .pyo files.
2017 hawking 1.37 #
2018 arfrever 1.92 # This function can be used only in pkg_postrm() phase.
2019 liquidx 1.1 python_mod_cleanup() {
2020 arfrever 1.87 _python_initialize_prefix_variables
2021 arfrever 1.90 _python_set_color_variables
2022 arfrever 1.87
2023 arfrever 1.90 local path py_file PYTHON_ABI="${PYTHON_ABI}" SEARCH_PATH=() root
2024 liquidx 1.16
2025 arfrever 1.56 # Check if phase is pkg_postrm().
2026 arfrever 1.95 [[ "${EBUILD_PHASE}" != "postrm" ]] && die "${FUNCNAME}() can be used only in pkg_postrm() phase"
2027 hawking 1.37
2028 arfrever 1.56 # Strip trailing slash from ROOT.
2029 arfrever 1.87 root="${EROOT%/}"
2030 liquidx 1.1
2031 hawking 1.50 if (($#)); then
2032 arfrever 1.95 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2033 arfrever 1.56 while (($#)); do
2034 arfrever 1.87 if ! _python_implementation && [[ "$1" =~ ^"${EPREFIX}"/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2035     die "${FUNCNAME}() does not support absolute paths of directories/files in site-packages directories"
2036 arfrever 1.56 elif [[ "$1" =~ ^/ ]]; then
2037     SEARCH_PATH+=("${root}/${1#/}")
2038     else
2039 arfrever 1.90 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI:-$(PYTHON --ABI)}}; do
2040 arfrever 1.62 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1")
2041 arfrever 1.56 done
2042     fi
2043     shift
2044     done
2045     else
2046     SEARCH_PATH=("${@#/}")
2047     SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}")
2048     fi
2049 liquidx 1.5 else
2050 arfrever 1.78 local dir sitedir
2051     for dir in "${root}"/usr/lib*; do
2052     if [[ -d "${dir}" && ! -L "${dir}" ]]; then
2053     for sitedir in "${dir}"/python*/site-packages; do
2054     if [[ -d "${sitedir}" ]]; then
2055     SEARCH_PATH+=("${sitedir}")
2056     fi
2057     done
2058     fi
2059     done
2060 arfrever 1.88 for sitedir in "${root}"/usr/share/jython-*/Lib/site-packages; do
2061     if [[ -d "${sitedir}" ]]; then
2062     SEARCH_PATH+=("${sitedir}")
2063     fi
2064     done
2065 arfrever 1.78 fi
2066    
2067 hawking 1.50 for path in "${SEARCH_PATH[@]}"; do
2068 arfrever 1.78 if [[ -d "${path}" ]]; then
2069 arfrever 1.88 find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0 | while read -rd ''; do
2070     if [[ "${REPLY}" == *[co] ]]; then
2071     py_file="${REPLY%[co]}"
2072     [[ -f "${py_file}" || (! -f "${py_file}c" && ! -f "${py_file}o") ]] && continue
2073 arfrever 1.94 echo "${_BLUE}<<< ${py_file}[co]${_NORMAL}"
2074 arfrever 1.88 rm -f "${py_file}"[co]
2075     elif [[ "${REPLY}" == *\$py.class ]]; then
2076     py_file="${REPLY%\$py.class}.py"
2077     [[ -f "${py_file}" || ! -f "${py_file%.py}\$py.class" ]] && continue
2078 arfrever 1.94 echo "${_BLUE}<<< ${py_file%.py}\$py.class${_NORMAL}"
2079 arfrever 1.88 rm -f "${py_file%.py}\$py.class"
2080     fi
2081 arfrever 1.78 done
2082 hawking 1.50
2083 arfrever 1.78 # Attempt to delete directories, which may be empty.
2084     find "${path}" -type d | sort -r | while read -r dir; do
2085 arfrever 1.94 rmdir "${dir}" 2>/dev/null && echo "${_CYAN}<<< ${dir}${_NORMAL}"
2086 arfrever 1.78 done
2087 arfrever 1.88 elif [[ "${path}" == *.py && ! -f "${path}" ]]; then
2088     if [[ (-f "${path}c" || -f "${path}o") ]]; then
2089 arfrever 1.94 echo "${_BLUE}<<< ${path}[co]${_NORMAL}"
2090 arfrever 1.88 rm -f "${path}"[co]
2091     fi
2092     if [[ -f "${path%.py}\$py.class" ]]; then
2093 arfrever 1.94 echo "${_BLUE}<<< ${path%.py}\$py.class${_NORMAL}"
2094 arfrever 1.88 rm -f "${path%.py}\$py.class"
2095     fi
2096 arfrever 1.78 fi
2097 pythonhead 1.7 done
2098 liquidx 1.1 }
2099 arfrever 1.85
2100     # ================================================================================================
2101     # ===================================== DEPRECATED FUNCTIONS =====================================
2102     # ================================================================================================
2103    
2104     # @FUNCTION: python_version
2105     # @DESCRIPTION:
2106     # Run without arguments and it will export the version of python
2107     # currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
2108     python_version() {
2109 arfrever 1.95 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2110 arfrever 1.88 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
2111 arfrever 1.87 die "${FUNCNAME}() cannot be used in this EAPI"
2112     fi
2113    
2114 arfrever 1.95 _python_set_color_variables
2115    
2116 arfrever 1.92 if [[ "${FUNCNAME[1]}" != "distutils_python_version" ]]; then
2117 arfrever 1.95 echo
2118     echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2119     echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables.${_NORMAL}"
2120     echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2121     echo
2122    
2123     einfo &> /dev/null
2124     einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2125     einfo "Use PYTHON() instead of python variable. Use python_get_*() instead of PYVER* variables." &> /dev/null
2126     einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2127     einfo &> /dev/null
2128 arfrever 1.92 fi
2129    
2130 arfrever 1.85 [[ -n "${PYVER}" ]] && return 0
2131     local tmpstr
2132 arfrever 1.87 python="${python:-${EPREFIX}/usr/bin/python}"
2133 arfrever 1.85 tmpstr="$(EPYTHON= ${python} -V 2>&1 )"
2134     export PYVER_ALL="${tmpstr#Python }"
2135 arfrever 1.86 export PYVER_MAJOR="${PYVER_ALL:0:1}"
2136     export PYVER_MINOR="${PYVER_ALL:2:1}"
2137     if [[ "${PYVER_ALL:3:1}" == "." ]]; then
2138     export PYVER_MICRO="${PYVER_ALL:4}"
2139     fi
2140     export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
2141 arfrever 1.85 }
2142    
2143 arfrever 1.91 # @FUNCTION: python_mod_exists
2144     # @USAGE: <module>
2145     # @DESCRIPTION:
2146     # Run with the module name as an argument. It will check if a
2147     # Python module is installed and loadable. It will return
2148     # TRUE(0) if the module exists, and FALSE(1) if the module does
2149     # not exist.
2150     #
2151     # Example:
2152     # if python_mod_exists gtk; then
2153     # echo "gtk support enabled"
2154     # fi
2155     python_mod_exists() {
2156 arfrever 1.95 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2157 arfrever 1.91 eerror "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()."
2158     die "${FUNCNAME}() cannot be used in this EAPI"
2159     fi
2160    
2161 arfrever 1.95 echo
2162     echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2163     echo " ${_RED}*${_NORMAL} ${_RED}Use USE dependencies and/or has_version() instead of ${FUNCNAME}().${_NORMAL}"
2164     echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2165     echo
2166    
2167     einfo &> /dev/null
2168     einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2169     einfo "Use USE dependencies and/or has_version() instead of ${FUNCNAME}()." &> /dev/null
2170     einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2171     einfo &> /dev/null
2172 arfrever 1.92
2173 arfrever 1.91 if [[ "$#" -ne 1 ]]; then
2174     die "${FUNCNAME}() requires 1 argument"
2175     fi
2176     "$(PYTHON ${PYTHON_ABI})" -c "import $1" &> /dev/null
2177     }
2178    
2179 arfrever 1.90 # @FUNCTION: python_tkinter_exists
2180     # @DESCRIPTION:
2181     # Run without arguments, checks if Python was compiled with Tkinter
2182     # support. If not, prints an error message and dies.
2183     python_tkinter_exists() {
2184 arfrever 1.95 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2185 arfrever 1.90 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
2186     die "${FUNCNAME}() cannot be used in this EAPI"
2187     fi
2188    
2189 arfrever 1.92 if [[ "${FUNCNAME[1]}" != "distutils_python_tkinter" ]]; then
2190 arfrever 1.95 echo
2191     echo " ${_RED}*${_NORMAL} ${_RED}Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01.${_NORMAL}"
2192     echo " ${_RED}*${_NORMAL} ${_RED}Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}().${_NORMAL}"
2193     echo " ${_RED}*${_NORMAL} ${_RED}The ebuild needs to be fixed. Please report a bug, if it has not been already reported.${_NORMAL}"
2194     echo
2195    
2196     einfo &> /dev/null
2197     einfo "Deprecation Warning: ${FUNCNAME}() is deprecated and will be banned on 2010-07-01." &> /dev/null
2198     einfo "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()." &> /dev/null
2199     einfo "The ebuild needs to be fixed. Please report a bug, if it has not been already reported." &> /dev/null
2200     einfo &> /dev/null
2201 arfrever 1.92 fi
2202    
2203 arfrever 1.90 if ! "$(PYTHON ${PYTHON_ABI})" -c "from sys import version_info
2204     if version_info[0] == 3:
2205     import tkinter
2206     else:
2207     import Tkinter" &> /dev/null; then
2208     eerror "Python needs to be rebuilt with tkinter support enabled."
2209     eerror "Add the following line to '${EPREFIX}/etc/portage/package.use' and rebuild Python"
2210     eerror "dev-lang/python tk"
2211     die "Python installed without support for tkinter"
2212     fi
2213     }
2214    
2215 arfrever 1.85 # @FUNCTION: python_mod_compile
2216     # @USAGE: <file> [more files ...]
2217     # @DESCRIPTION:
2218     # Given filenames, it will pre-compile the module's .pyc and .pyo.
2219 arfrever 1.92 # This function can be used only in pkg_postinst() phase.
2220 arfrever 1.85 #
2221     # Example:
2222     # python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
2223     #
2224     python_mod_compile() {
2225 arfrever 1.95 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis; then
2226 arfrever 1.88 eerror "Use python_mod_optimize() instead of ${FUNCNAME}()."
2227 arfrever 1.85 die "${FUNCNAME}() cannot be used in this EAPI"
2228     fi
2229    
2230 arfrever 1.87 _python_initialize_prefix_variables
2231    
2232 arfrever 1.85 local f myroot myfiles=()
2233    
2234     # Check if phase is pkg_postinst()
2235 arfrever 1.95 [[ "${EBUILD_PHASE}" != "postinst" ]] && die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2236 arfrever 1.85
2237     # strip trailing slash
2238 arfrever 1.87 myroot="${EROOT%/}"
2239 arfrever 1.85
2240     # respect ROOT
2241     for f in "$@"; do
2242     [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
2243     done
2244    
2245     if ((${#myfiles[@]})); then
2246 arfrever 1.90 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}"
2247     "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null
2248 arfrever 1.85 else
2249     ewarn "No files to compile!"
2250     fi
2251     }

  ViewVC Help
Powered by ViewVC 1.1.20